module Paths_ImperativeHaskell (
    version,
    getBinDir, getLibDir, getDataDir, getLibexecDir,
    getDataFileName
  ) where

import Data.Version (Version(..))
import System.Environment (getEnv)

version :: Version
version = Version {versionBranch = [2,0,0,0], versionTags = []}

bindir, libdir, datadir, libexecdir :: FilePath

bindir     = "/Users/matt/.cabal/bin"
libdir     = "/Users/matt/.cabal/lib/ImperativeHaskell-2.0.0.0/ghc-7.4.1"
datadir    = "/Users/matt/.cabal/share/ImperativeHaskell-2.0.0.0"
libexecdir = "/Users/matt/.cabal/libexec"

getBinDir, getLibDir, getDataDir, getLibexecDir :: IO FilePath
getBinDir = catch (getEnv "ImperativeHaskell_bindir") (\_ -> return bindir)
getLibDir = catch (getEnv "ImperativeHaskell_libdir") (\_ -> return libdir)
getDataDir = catch (getEnv "ImperativeHaskell_datadir") (\_ -> return datadir)
getLibexecDir = catch (getEnv "ImperativeHaskell_libexecdir") (\_ -> return libexecdir)

getDataFileName :: FilePath -> IO FilePath
getDataFileName name = do
  dir <- getDataDir
  return (dir ++ "/" ++ name)
